var AMWAY = AMWAY || {};
AMWAY.IncomeSimulator = AMWAY.IncomeSimulator || {};

AMWAY.IncomeSimulator.Loader = (function(){
	
	var _queue = [];
	var _settings = {
		dataType: 'json'
	};
	
	/**
	 * Load a single json file and pass loaded data
	 * to callback function.
	 */
	var _load = function(url, callback)
	{
		$.ajax({
			url: url,
			dataType: _settings.dataType,
			success: function(data){
				if(callback instanceof Function)
				{
					callback(data);
				}
			},
			error: function(xhr, status, error) {
     			alert(xhr.status);
   			}
		});
	};
	
	/**
	 * Add a json file and callback to a loading queue.
	 */
	var _addToQueue = function(url, callback)
	{
		_queue.push([url, eval(callback)]);
	};
	
	/**
	 * Load each url in the loading queue, calling an optional
	 * callback when the queue is finished loading.
	 */
	var _processQueue = function(callback, mode, dataType)
	{
		if(_queue.length > 0)
		{
			var loadArray = _queue.shift();

			$.ajax({
				url: loadArray[0],
				dataType: _settings.dataType,
				success: function(data){
					if(loadArray[1] instanceof Function)
					{
						loadArray[1](data);
					}
					
					_processQueue(callback, mode, dataType);
				},
				error: function(xhr, status, error) {
     				alert(xhr.status);
     				for(var i in xhr)
     				{
     					//alert("["+i+"] "+xhr[i]);
     				}
   				}
			});
			return;
		}
		
		var cb = eval(callback);
		if(cb instanceof Function)
		{
			cb();
		}
	};
	
	/**
	 * Public properties and methods
	 */
	return {
		load: _load,
		addToQueue: _addToQueue,
		processQueue: _processQueue,
		settings: _settings
	};
}());