function isNumeric(input)
{
   return (input - 0) == input && input != undefined;
}

Number.prototype.formatMoney = function(c,p,d,t)
{
	// decimal places
	p = isNaN(p = Math.abs(p)) ? 2 : p;
	// decimal symbol
	d = d == undefined ? "," : d;
	// thousands symbol
	t = t == undefined ? "." : t;
	
	var n = this;
	// signed
	var s = n < 0 ? "-" : "";
	// integer
	var i = parseInt(n = Math.abs(+n || 0).toFixed(p)) + "";
	var j = (j = i.length) > 3 ? j % 3 : 0;

	return s + c + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (p ? d + Math.abs(n - i).toFixed(p).slice(2) : "");
};